diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/macros-and-definitions.cmake ns-3.39/build-support/macros-and-definitions.cmake
--- ns-3.38/build-support/macros-and-definitions.cmake	2023-03-16 20:54:23.496868100 -0700
+++ ns-3.39/build-support/macros-and-definitions.cmake	2023-07-05 14:23:47.589426500 -0700
@@ -36,6 +36,9 @@
        "Set executables ownership to root and enable the SUID flag" OFF
 )
 
+# a flag that controls some aspects related to pip packaging
+option(NS3_PIP_PACKAGING "Control aspects related to pip wheel packaging" OFF)
+
 # Replace default CMake messages (logging) with custom colored messages as early
 # as possible
 include(${PROJECT_SOURCE_DIR}/build-support/3rd-party/colored-messages.cmake)
@@ -71,6 +74,11 @@
   set(NS3_PRECOMPILE_HEADERS OFF
       CACHE BOOL "Precompile module headers to speed up compilation" FORCE
   )
+
+  # For whatever reason getting M_PI and other math.h definitions from cmath
+  # requires this definition
+  # https://docs.microsoft.com/en-us/cpp/c-runtime-library/math-constants?view=vs-2019
+  add_definitions(/D_USE_MATH_DEFINES)
 endif()
 
 set(cat_command cat)
@@ -148,6 +156,25 @@
 include(GNUInstallDirs)
 include(build-support/custom-modules/ns3-cmake-package.cmake)
 
+# Set RPATH not too need LD_LIBRARY_PATH after installing
+set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib:$ORIGIN/:$ORIGIN/../lib")
+
+# Add the 64 suffix to the library path when manually requested with the
+# -DNS3_USE_LIB64=ON flag. May be necessary depending on the target platform.
+# This is used to properly build the manylinux pip wheel.
+if(${NS3_USE_LIB64})
+  link_directories(${CMAKE_OUTPUT_DIRECTORY}/lib64)
+  set(CMAKE_INSTALL_RPATH
+      "${CMAKE_INSTALL_RPATH}:${CMAKE_INSTALL_PREFIX}/lib64:$ORIGIN/:$ORIGIN/../lib64"
+  )
+endif()
+
+# cmake-format: off
+# You are a wizard, Harry!
+# source: https://gitlab.kitware.com/cmake/community/-/wikis/doc/cmake/RPATH-handling
+# cmake-format: on
+set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
 if(${XCODE})
   # Is that so hard not to break people's CI, AAPL? Why would you output the
   # targets to a Debug/Release subfolder? Why?
@@ -202,6 +229,7 @@
 endif()
 
 set(GCC FALSE)
+set(GCC8 FALSE)
 if("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
   if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${GNU_MinVersion})
     message(
@@ -209,6 +237,12 @@
         "GNU ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${GNU_MinVersion}"
     )
   endif()
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.0.0")
+    # This block is used to identify if GCC8 is being used. In this case, we
+    # want to explicitly link stdc++fs, which is done in
+    # ns3-module-macros.cmake.
+    set(GCC8 TRUE)
+  endif()
   set(GCC TRUE)
   add_definitions(-fno-semantic-interposition)
   if(${NS3_COLORED_OUTPUT} OR "$ENV{CLICOLOR}")
@@ -222,6 +256,7 @@
 set(CXX_UNSUPPORTED_STANDARDS 98 11 14)
 set(CMAKE_CXX_STANDARD_MINIMUM 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 set(LIB_AS_NEEDED_PRE)
 set(LIB_AS_NEEDED_POST)
 set(STATIC_LINK_FLAGS -static -static-libstdc++ -static-libgcc)
@@ -308,7 +343,6 @@
   unset(ns3-headers-to-module-map CACHE)
   unset(ns3-libs CACHE)
   unset(ns3-libs-tests CACHE)
-  unset(ns3-python-bindings-modules CACHE)
   mark_as_advanced(
     build_profile
     build_profile_suffix
@@ -322,7 +356,6 @@
     ns3-headers-to-module-map
     ns3-libs
     ns3-libs-tests
-    ns3-python-bindings-modules
   )
 endmacro()
 
@@ -410,6 +443,8 @@
   if(${NS3_TESTS} OR ${ns3rc_tests_enabled})
     set(ENABLE_TESTS ON)
     enable_testing()
+  else()
+    list(REMOVE_ITEM libs_to_build test)
   endif()
 
   set(profiles_without_suffixes release)
@@ -553,11 +588,11 @@
       cmake-format
       COMMAND
         ${CMAKE_FORMAT_PROGRAM} -c
-        ${PROJECT_SOURCE_DIR}/build-support/cmake-format.txt -i
+        ${PROJECT_SOURCE_DIR}/build-support/cmake-format.yaml -i
         ${INTERNAL_CMAKE_FILES}
       COMMAND
         ${CMAKE_FORMAT_PROGRAM} -c
-        ${PROJECT_SOURCE_DIR}/build-support/cmake-format-modules.txt -i
+        ${PROJECT_SOURCE_DIR}/build-support/cmake-format-modules.yaml -i
         ${MODULES_CMAKE_FILES}
     )
     unset(MODULES_CMAKE_FILES)
@@ -802,7 +837,7 @@
       find_package(Python3 COMPONENTS Interpreter Development)
     else()
       # cmake-format: off
-      set(Python_ADDITIONAL_VERSIONS 3.1 3.2 3.3 3.4 3.5 3.6 3.7 3.8 3.9)
+      set(Python_ADDITIONAL_VERSIONS 3.6 3.7 3.8 3.9 3.10 3.11)
       # cmake-format: on
       find_package(PythonInterp)
       find_package(PythonLibs)
@@ -856,10 +891,12 @@
       )
     endif()
   else()
-    message(
-      ${HIGHLIGHTED_STATUS}
-      "Python: an incompatible version of Python was found, python bindings will be disabled"
-    )
+    if(${NS3_PYTHON_BINDINGS})
+      message(
+        ${HIGHLIGHTED_STATUS}
+        "Python: an incompatible version of Python was found, python bindings will be disabled"
+      )
+    endif()
   endif()
 
   set(ENABLE_PYTHON_BINDINGS OFF)
@@ -901,12 +938,16 @@
         message(
           ${HIGHLIGHTED_STATUS}
           "NS3_BINDINGS_INSTALL_DIR was not set. The python bindings won't be installed with ./ns3 install."
+          "This setting is meant for packaging and redistribution."
         )
         message(
           ${HIGHLIGHTED_STATUS}
           "Set NS3_BINDINGS_INSTALL_DIR=\"${SUGGESTED_BINDINGS_INSTALL_DIR}\" to install it to the default location."
         )
       else()
+        if(${NS3_BINDINGS_INSTALL_DIR} STREQUAL "INSTALL_PREFIX")
+          set(NS3_BINDINGS_INSTALL_DIR ${CMAKE_INSTALL_PREFIX})
+        endif()
         install(FILES bindings/python/ns__init__.py
                 DESTINATION ${NS3_BINDINGS_INSTALL_DIR}/ns RENAME __init__.py
         )
@@ -1350,8 +1391,6 @@
   set(ns3-contrib-libs)
   set(lib-ns3-static-objs)
   set(ns3-external-libs)
-  set(ns3-python-bindings ns${NS3_VER}-pybindings${build_profile_suffix})
-  set(ns3-python-bindings-modules)
 
   foreach(libname ${scanned_modules})
     # Create libname of output library of module
@@ -1477,7 +1516,7 @@
     include(FetchContent)
     FetchContent_Declare(
       netanim GIT_REPOSITORY https://gitlab.com/nsnam/netanim.git
-      GIT_TAG netanim-3.108
+      GIT_TAG netanim-3.109
     )
     FetchContent_Populate(netanim)
     file(COPY build-support/3rd-party/netanim-cmakelists.cmake
@@ -1577,8 +1616,11 @@
   )
 
   # Resolve nested scratch prefixes without user intervention
-  if("${CMAKE_CURRENT_SOURCE_DIR}" MATCHES "scratch"
-     AND "${BEXEC_EXECNAME_PREFIX}" STREQUAL ""
+  string(REPLACE "${PROJECT_SOURCE_DIR}" "" relative_path
+                 "${CMAKE_CURRENT_SOURCE_DIR}"
+  )
+  if("${relative_path}" MATCHES "scratch" AND "${BEXEC_EXECNAME_PREFIX}"
+                                              STREQUAL ""
   )
     get_scratch_prefix(BEXEC_EXECNAME_PREFIX)
   endif()
@@ -1926,10 +1968,6 @@
       unset(dependencies)
       unset(contrib_dependencies)
     endforeach()
-
-    if(core IN_LIST ${libs_to_build})
-      list(APPEND ${libs_to_build} test) # include test module
-    endif()
   endif()
 
   if(${NS3_DISABLED_MODULES} OR ${ns3rc_disabled_modules})
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/pip-wheel/auditwheel-exclude-list.py ns-3.39/build-support/pip-wheel/auditwheel-exclude-list.py
--- ns-3.38/build-support/pip-wheel/auditwheel-exclude-list.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/pip-wheel/auditwheel-exclude-list.py	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,11 @@
+import os
+
+ns3_path = os.path.dirname(os.path.abspath(os.sep.join([__file__, "../../"])))
+
+for variant in ["lib", "lib64"]:
+    lib_dir = os.path.abspath(os.path.join(ns3_path, f"build/{variant}"))
+    if not os.path.exists(lib_dir):
+        continue
+    for lib in os.listdir(lib_dir):
+        if "libns3" in lib:
+            print(f"--exclude {lib}", end=' ')
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/pip-wheel/ns/__init__.py ns-3.39/build-support/pip-wheel/ns/__init__.py
--- ns-3.38/build-support/pip-wheel/ns/__init__.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/pip-wheel/ns/__init__.py	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,10 @@
+# This is a stub module that loads the actual ns-3
+# bindings from ns3.ns
+import sys
+
+try:
+    import ns3.ns
+    sys.modules['ns'] = ns3.ns
+except ModuleNotFoundError as e:
+    print("Install the ns3 package with pip install ns3.", file=sys.stderr)
+    exit(-1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/pip-wheel/visualizer/__init__.py ns-3.39/build-support/pip-wheel/visualizer/__init__.py
--- ns-3.38/build-support/pip-wheel/visualizer/__init__.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/pip-wheel/visualizer/__init__.py	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,11 @@
+# This is a stub module that loads the actual visualizer
+# from ns3.visualizer
+import sys
+
+try:
+    import ns3.visualizer
+except ModuleNotFoundError as e:
+    print("Install the ns3 package with pip install ns3.", file=sys.stderr)
+    exit(-1)
+
+from ns3.visualizer import start, register_plugin, set_bounds, add_initialization_hook
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-contrib-dependency/CMakeLists.txt ns-3.39/build-support/test-files/test-contrib-dependency/CMakeLists.txt
--- ns-3.38/build-support/test-files/test-contrib-dependency/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-contrib-dependency/CMakeLists.txt	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,6 @@
+build_lib(
+        LIBNAME test-contrib-dependency
+        SOURCE_FILES contrib-source.cc
+        HEADER_FILES contrib-header.h
+        LIBRARIES_TO_LINK ${libcore}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-contrib-dependency/contrib-header.h ns-3.39/build-support/test-files/test-contrib-dependency/contrib-header.h
--- ns-3.38/build-support/test-files/test-contrib-dependency/contrib-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-contrib-dependency/contrib-header.h	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,6 @@
+#ifndef NS3_CONTRIB_HEADER_H
+#define NS3_CONTRIB_HEADER_H
+
+void testPrint();
+
+#endif // NS3_CONTRIB_HEADER_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-contrib-dependency/contrib-source.cc ns-3.39/build-support/test-files/test-contrib-dependency/contrib-source.cc
--- ns-3.38/build-support/test-files/test-contrib-dependency/contrib-source.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-contrib-dependency/contrib-source.cc	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,9 @@
+#include "contrib-header.h"
+
+#include <ns3/simulator.h>
+
+void
+testPrint()
+{
+    std::cout << ns3::Simulator::Now() << std::endl;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-src-dependant-on-contrib/CMakeLists.txt ns-3.39/build-support/test-files/test-src-dependant-on-contrib/CMakeLists.txt
--- ns-3.38/build-support/test-files/test-src-dependant-on-contrib/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-src-dependant-on-contrib/CMakeLists.txt	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,8 @@
+build_lib(
+        LIBNAME test-src-dependant-on-contrib
+        SOURCE_FILES src-source.cc
+        HEADER_FILES src-header.h
+        LIBRARIES_TO_LINK ${libcore}
+                          ${libtest-contrib-dependency}
+)
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-src-dependant-on-contrib/examples/CMakeLists.txt ns-3.39/build-support/test-files/test-src-dependant-on-contrib/examples/CMakeLists.txt
--- ns-3.38/build-support/test-files/test-src-dependant-on-contrib/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-src-dependant-on-contrib/examples/CMakeLists.txt	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,6 @@
+build_lib_example(
+        NAME source-example
+        SOURCE_FILES source-example.cc
+        LIBRARIES_TO_LINK
+        ${libtest-src-dependant-on-contrib}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-src-dependant-on-contrib/examples/source-example.cc ns-3.39/build-support/test-files/test-src-dependant-on-contrib/examples/source-example.cc
--- ns-3.38/build-support/test-files/test-src-dependant-on-contrib/examples/source-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-src-dependant-on-contrib/examples/source-example.cc	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,8 @@
+#include <ns3/src-header.h>
+
+int
+main()
+{
+    testPrint2();
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-src-dependant-on-contrib/src-header.h ns-3.39/build-support/test-files/test-src-dependant-on-contrib/src-header.h
--- ns-3.38/build-support/test-files/test-src-dependant-on-contrib/src-header.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-src-dependant-on-contrib/src-header.h	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,6 @@
+#ifndef NS3_SRC_SOURCE2_H
+#define NS3_SRC_SOURCE2_H
+
+void testPrint2();
+
+#endif // NS3_SOURCE_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/build-support/test-files/test-src-dependant-on-contrib/src-source.cc ns-3.39/build-support/test-files/test-src-dependant-on-contrib/src-source.cc
--- ns-3.38/build-support/test-files/test-src-dependant-on-contrib/src-source.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/build-support/test-files/test-src-dependant-on-contrib/src-source.cc	2023-07-05 14:23:47.589426500 -0700
@@ -0,0 +1,7 @@
+#include <ns3/contrib-header.h>
+
+void
+testPrint2()
+{
+    testPrint();
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/.clang-tidy ns-3.39/.clang-tidy
--- ns-3.38/.clang-tidy	2023-03-16 20:54:23.484868000 -0700
+++ ns-3.39/.clang-tidy	2023-07-05 14:23:47.577426400 -0700
@@ -28,23 +28,29 @@
   performance-inefficient-algorithm,
   performance-inefficient-vector-operation,
   performance-trivially-destructible,
+  performance-unnecessary-copy-initialization,
   readability-braces-around-statements,
   readability-container-size-empty,
-  readability-duplicate-include,
   readability-isolate-declaration,
   readability-make-member-function-const,
-  readability-misleading-indentation,
   readability-misplaced-array-index,
   readability-redundant-control-flow,
   readability-redundant-function-ptr-dereference,
   readability-redundant-smartptr-get,
   readability-redundant-string-cstr,
+  readability-simplify-boolean-expr,
   readability-simplify-subscript-expr,
   readability-static-accessed-through-instance,
   readability-static-definition-in-anonymous-namespace,
   readability-string-compare,
   readability-uppercase-literal-suffix,
 
+CheckOptions:
+  - key: performance-unnecessary-copy-initialization.AllowedTypes
+    value: Ptr
+  - key: readability-simplify-boolean-expr.SimplifyDeMorgan
+    value: false
+
 FormatStyle: "file"
 HeaderFilterRegex: ".*(ns|NS).*/(contrib|examples|src|scratch|utils)/*/.*h"
 UseColor: true
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/CMakeLists.txt ns-3.39/CMakeLists.txt
--- ns-3.38/CMakeLists.txt	2023-03-16 20:54:23.488868200 -0700
+++ ns-3.39/CMakeLists.txt	2023-07-05 14:23:47.581426600 -0700
@@ -25,6 +25,7 @@
 # fd-net-device options
 option(NS3_EMU "Build with emulation support" ON)
 option(NS3_TAP "Build with Tap support" ON)
+option(NS3_DPDK "Enable fd-net-device DPDK features" OFF)
 
 # maintenance and documentation
 option(NS3_CLANG_FORMAT "Enforce cody style with clang-format" OFF)
@@ -92,8 +93,8 @@
 set(NS3_ENABLED_MODULES ""
     CACHE STRING "List of modules to enable (e.g. core;network;internet)"
 )
-set(NS3_DISABLED_MODULES ""
-    CACHE STRING "List of modules to disable (e.g. lte;wimax;wave)"
+set(NS3_DISABLED_MODULES "" CACHE STRING
+                                  "List of modules to disable (e.g. lte;wimax)"
 )
 
 # Filter in the modules from which examples and tests will be built
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/doc/doxygen.conf ns-3.39/doc/doxygen.conf
--- ns-3.38/doc/doxygen.conf	2023-03-16 20:54:23.500868000 -0700
+++ ns-3.39/doc/doxygen.conf	2023-07-05 14:23:47.593426700 -0700
@@ -1881,7 +1881,7 @@
 # If left blank no extra packages will be included.
 # This tag requires that the tag GENERATE_LATEX is set to YES.
 
-EXTRA_PACKAGES         = amsmath
+EXTRA_PACKAGES         = amsmath,amssymb
 
 # The LATEX_HEADER tag can be used to specify a user-defined LaTeX header for
 # the generated LaTeX document. The header should contain everything until the
@@ -2693,5 +2693,5 @@
 DOT_CLEANUP            = YES
 
 # Disable dark mode in the generated HTML in Doxygen 1.9.6 or greater.
-HTML_COLORSTYLE        = LIGHT
+# HTML_COLORSTYLE        = LIGHT
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/doc/models/Makefile ns-3.39/doc/models/Makefile
--- ns-3.38/doc/models/Makefile	2023-03-16 20:54:23.536868300 -0700
+++ ns-3.39/doc/models/Makefile	2023-07-05 14:23:47.633426700 -0700
@@ -98,7 +98,6 @@
 	$(SRC)/spectrum/doc/spectrum.rst \
 	$(SRC)/netanim/doc/animation.rst \
 	$(SRC)/flow-monitor/doc/flow-monitor.rst \
-	$(SRC)/wave/doc/wave.rst \
 	$(SRC)/sixlowpan/doc/sixlowpan.rst \
 	$(SRC)/lr-wpan/doc/lr-wpan.rst \
 
@@ -161,6 +160,10 @@
 	$(SRC)/wifi/doc/source/figures/wifi-11g-p-1500-infrastructure-r-6-min-5-max-50-step-5-throughput.eps \
 	$(SRC)/wifi/doc/source/figures/default-table-based-error-model-validation.eps \
 	$(SRC)/wifi/doc/source/figures/error-models-comparison.eps \
+	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.pdf \
+	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.png \
+	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.pdf \
+	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.png \
 	$(SRC)/wimax/doc/WimaxArchitecture.dia \
 	$(SRC)/lte/doc/source/figures/epc-ctrl-arch.dia \
 	$(SRC)/lte/doc/source/figures/epc-data-flow-dl.dia \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/doc/ns3_html_theme/static/default.css_t ns-3.39/doc/ns3_html_theme/static/default.css_t
--- ns-3.38/doc/ns3_html_theme/static/default.css_t	2023-03-16 20:54:23.536868300 -0700
+++ ns-3.39/doc/ns3_html_theme/static/default.css_t	2023-07-05 14:23:47.633426700 -0700
@@ -61,7 +61,7 @@
 }
 
 div.related {
-    background-color: {{ theme_relbarbgcolor }};
+    background-image: linear-gradient(to bottom, white 0%, transparent 80%);
     line-height: 30px;
     color: {{ theme_relbartextcolor }};
 }
@@ -142,9 +142,16 @@
 }
 
 div.sphinxsidebar input {
-    border: 1px solid {{ theme_sidebarlinkcolor }};
+    border: 2px solid {{ theme_sidebarlinkcolor }};
     font-family: sans-serif;
     font-size: 1em;
+    font-weight: bold;
+    background: #f0f1e8;
+}
+
+div.sphinxsidebar input[type="submit"] {
+    background: {{ theme_sidebarlinkcolor }};
+    color: {{theme_sidebartextcolor}};
 }
 
 {% if theme_collapsiblesidebar|tobool %}
@@ -196,12 +203,12 @@
 div.body h5,
 div.body h6 {
     font-family: {{ theme_headfont }};
-    background-color: {{ theme_headbgcolor }};
-    font-weight: normal;
-    color: {{ theme_headtextcolor }};
+    background-color: transparent;
+    font-weight: bold;
     border-bottom: 1px solid #ccc;
     margin: 20px -20px 10px -20px;
-    padding: 3px 0 3px 10px;
+    padding: 10px 8px;
+    border-left: 6px solid #d7d4d2;
 }
 
 div.body h1 { margin-top: 0; font-size: 200%; }
@@ -273,7 +280,7 @@
 
 pre {
     padding: 5px;
-    background-color: {{ theme_codebgcolor }};
+    background-color: transparent;
     color: {{ theme_codetextcolor }};
     line-height: 120%;
     border: 1px solid #ac9;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/doc/ns3_html_theme/static/ns3_links.js ns-3.39/doc/ns3_html_theme/static/ns3_links.js
--- ns-3.38/doc/ns3_html_theme/static/ns3_links.js	2023-03-16 20:54:23.536868300 -0700
+++ ns-3.39/doc/ns3_html_theme/static/ns3_links.js	2023-07-05 14:23:47.633426700 -0700
@@ -44,6 +44,7 @@
 var ns3_mod  = ns3_rel  + "models/"         + ns3_index;
 var ns3_tut  = ns3_rel  + "tutorial/"       + ns3_index;
 var ns3_con  = ns3_rel  + "contributing/"   + ns3_index;
+var ns3_ins  = ns3_rel  + "installation/"   + ns3_index;
 
 function ns3_write_links() {
   document.getElementById("ns3_home1").href = ns3_home;
@@ -52,6 +53,7 @@
   document.getElementById("ns3_man"  ).href = ns3_man;
   document.getElementById("ns3_mod"  ).href = ns3_mod;
   document.getElementById("ns3_con"  ).href = ns3_con;
+  document.getElementById("ns3_ins"  ).href = ns3_ins;
   document.getElementById("ns3_wiki" ).href = ns3_wiki;
   document.getElementById("ns3_api"  ).href = ns3_api;
   document.getElementById("ns3_bugs" ).href = ns3_bugs;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/doc/ns3_html_theme/theme.conf ns-3.39/doc/ns3_html_theme/theme.conf
--- ns-3.38/doc/ns3_html_theme/theme.conf	2023-03-16 20:54:23.536868300 -0700
+++ ns-3.39/doc/ns3_html_theme/theme.conf	2023-07-05 14:23:47.633426700 -0700
@@ -42,7 +42,7 @@
 footerbgcolor    = #D5D5D5
 footertextcolor	 = #364D7C
 
-codebgcolor      = ##FBFCFD
+codebgcolor      = #FBFCFD
 codetextcolor    = black
 
 bodyfont = 'Lucida Grande', Verdana, Geneva, Arial, sans-serif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/.editorconfig ns-3.39/.editorconfig
--- ns-3.38/.editorconfig	2023-03-16 20:54:23.484868000 -0700
+++ ns-3.39/.editorconfig	2023-07-05 14:23:47.577426400 -0700
@@ -31,6 +31,6 @@
 indent_style = space
 indent_size = 2
 
-[*.yml]
+[*.{md,rst,yml,yaml}]
 indent_style = space
 indent_size = 2
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/channel-models/examples-to-run.py ns-3.39/examples/channel-models/examples-to-run.py
--- ns-3.38/examples/channel-models/examples-to-run.py	2023-03-16 20:54:23.564868500 -0700
+++ ns-3.39/examples/channel-models/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/energy/examples-to-run.py ns-3.39/examples/energy/examples-to-run.py
--- ns-3.38/examples/energy/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/energy/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/error-model/examples-to-run.py ns-3.39/examples/error-model/examples-to-run.py
--- ns-3.38/examples/error-model/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/error-model/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/ipv6/examples-to-run.py ns-3.39/examples/ipv6/examples-to-run.py
--- ns-3.38/examples/ipv6/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/ipv6/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/ipv6/fragmentation-ipv6.cc ns-3.39/examples/ipv6/fragmentation-ipv6.cc
--- ns-3.38/examples/ipv6/fragmentation-ipv6.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/ipv6/fragmentation-ipv6.cc	2023-07-05 14:23:47.665426700 -0700
@@ -30,7 +30,6 @@
 #include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
-#include "ns3/internet-apps-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/ipv6-routing-table-entry.h"
 #include "ns3/ipv6-static-routing-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/ipv6/fragmentation-ipv6-PMTU.cc ns-3.39/examples/ipv6/fragmentation-ipv6-PMTU.cc
--- ns-3.38/examples/ipv6/fragmentation-ipv6-PMTU.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/ipv6/fragmentation-ipv6-PMTU.cc	2023-07-05 14:23:47.665426700 -0700
@@ -33,7 +33,6 @@
 #include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
-#include "ns3/internet-apps-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/ipv6-routing-table-entry.h"
 #include "ns3/ipv6-static-routing-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/ipv6/fragmentation-ipv6-two-MTU.cc ns-3.39/examples/ipv6/fragmentation-ipv6-two-MTU.cc
--- ns-3.38/examples/ipv6/fragmentation-ipv6-two-MTU.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/ipv6/fragmentation-ipv6-two-MTU.cc	2023-07-05 14:23:47.665426700 -0700
@@ -32,7 +32,6 @@
 #include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
-#include "ns3/internet-apps-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/ipv6-routing-table-entry.h"
 #include "ns3/ipv6-static-routing-helper.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/matrix-topology/matrix-topology.cc ns-3.39/examples/matrix-topology/matrix-topology.cc
--- ns-3.38/examples/matrix-topology/matrix-topology.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/matrix-topology/matrix-topology.cc	2023-07-05 14:23:47.665426700 -0700
@@ -60,7 +60,7 @@
 // ---------- Prototypes ------------------------------------------------------
 
 std::vector<std::vector<bool>> readNxNMatrix(std::string adj_mat_file_name);
-std::vector<std::vector<double>> readCordinatesFile(std::string node_coordinates_file_name);
+std::vector<std::vector<double>> readCoordinatesFile(std::string node_coordinates_file_name);
 void printCoordinateArray(const char* description, std::vector<std::vector<double>> coord_array);
 void printMatrix(const char* description, std::vector<std::vector<bool>> array);
 
@@ -115,7 +115,7 @@
     // ---------- Read Node Coordinates File -----------------------------------
 
     std::vector<std::vector<double>> coord_array;
-    coord_array = readCordinatesFile(node_coordinates_file_name);
+    coord_array = readCoordinatesFile(node_coordinates_file_name);
 
     // Optionally display node coordinates file
     // printCoordinateArray (node_coordinates_file_name.c_str (),coord_array);
@@ -361,7 +361,7 @@
 }
 
 std::vector<std::vector<double>>
-readCordinatesFile(std::string node_coordinates_file_name)
+readCoordinatesFile(std::string node_coordinates_file_name)
 {
     std::ifstream node_coordinates_file;
     node_coordinates_file.open(node_coordinates_file_name, std::ios::in);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/naming/examples-to-run.py ns-3.39/examples/naming/examples-to-run.py
--- ns-3.38/examples/naming/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/naming/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/naming/object-names.cc ns-3.39/examples/naming/object-names.cc
--- ns-3.38/examples/naming/object-names.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/naming/object-names.cc	2023-07-05 14:23:47.665426700 -0700
@@ -214,7 +214,7 @@
         outputValidated = false;
     }
 
-    if (outputValidated == false)
+    if (!outputValidated)
     {
         std::cerr << "Program internal checking failed; returning with error" << std::endl;
         return (1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/realtime/examples-to-run.py ns-3.39/examples/realtime/examples-to-run.py
--- ns-3.38/examples/realtime/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/realtime/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/routing/CMakeLists.txt ns-3.39/examples/routing/CMakeLists.txt
--- ns-3.38/examples/routing/CMakeLists.txt	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/routing/CMakeLists.txt	2023-07-05 14:23:47.665426700 -0700
@@ -87,6 +87,7 @@
     ${libolsr}
     ${libinternet}
     ${libapplications}
+    ${libflow-monitor}
 )
 
 build_example(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/routing/examples-to-run.py ns-3.39/examples/routing/examples-to-run.py
--- ns-3.38/examples/routing/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/routing/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
